diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index 2e9e08292..ae4a7f074 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -4,15 +4,17 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -24,7 +26,7 @@ public class BlockLogicCropsPumpkin
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final int meta = source.getBlockData(tilePos);
         final float onePix = 1.0F / 16.0F;
         float size = 0.0f;
@@ -40,7 +42,7 @@ public class BlockLogicCropsPumpkin
             size = 14 * onePix;
         }
 
-        return AABB.fromPool(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
+        return new AABBd(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
     }
 
     @Override
@@ -49,9 +51,9 @@ public class BlockLogicCropsPumpkin
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
-        if (world.getBlockLightValue(tilePos.up()) >= 9) {
+        if (world.getBlockLightValue(tilePos.up(new TilePos())) >= 9) {
             int meta = world.getBlockData(tilePos);
             if (meta < 6) {
                 final float f = this.getGrowthRate(world, tilePos);
@@ -67,16 +69,17 @@ public class BlockLogicCropsPumpkin
         }
     }
 
-    private float getGrowthRate(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private float getGrowthRate(final @NotNull World world, final @NotNull TilePosc tilePos) {
         float growthRate = 1.0F;
         final @NotNull TilePos localPos = new TilePos(tilePos);
-        for (localPos.x = tilePos.x - 1; localPos.x <= tilePos.x + 1; localPos.x++) {
-            for (localPos.z = tilePos.z - 1; localPos.z <= tilePos.z + 1; localPos.z++) {
-                final int id = world.getBlockId(localPos.down());
+        final @NotNull TilePos queryPos = new TilePos();
+        for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
+            for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
+                final int id = world.getBlockId(localPos.down(queryPos));
                 float growthRateMod = 0.0F;
                 if (id == Blocks.FARMLAND_DIRT.id()) {
                     growthRateMod = 1.0F;
-                    if (world.getBlockData(localPos.down()) > 0) {
+                    if (world.getBlockData(localPos.down(queryPos)) > 0) {
                         growthRateMod = 3F;
                     }
                 }
@@ -88,7 +91,7 @@ public class BlockLogicCropsPumpkin
 
         }
 
-        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down()));
+        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down(queryPos)));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null) {
                 growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
@@ -105,16 +108,16 @@ public class BlockLogicCropsPumpkin
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final int meta = source.getBlockData(tilePos);
         if (meta == 0) {
             return null;
         }
-        return this.getBoundsFromState(source, tilePos).move(tilePos);
+        return this.getBoundsFromState(source, tilePos).translate(tilePos.x(), tilePos.y(), tilePos.z(), new AABBd());
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         if (world.getBlockData(tilePos) < 5) {
             if (!world.isClientSide) {
                 world.setBlockIdNotify(tilePos, Blocks.PUMPKIN.id());
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index 3ab4117a8..67ae856f1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -32,9 +33,9 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         super.updateTick(world, tilePos, rand, isRandomTick);
-        if (world.getBlockLightValue(tilePos.up()) >= 9) {
+        if (world.getBlockLightValue(tilePos.up(new TilePos())) >= 9) {
             final int data = world.getBlockData(tilePos);
             if (data < MAX_GROWTH_STATE) {
                 final float growthRate = this.getGrowthRate(world, tilePos);
@@ -45,28 +46,29 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
         }
     }
 
-    private float getGrowthRate(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private float getGrowthRate(final @NotNull World world, final @NotNull TilePosc tilePos) {
         float growthRate = 1.0F;
-        final int idNegZ = world.getBlockId(tilePos.north());
-        final int idPosZ = world.getBlockId(tilePos.south());
-        final int idNegX = world.getBlockId(tilePos.west());
-        final int idPosX = world.getBlockId(tilePos.east());
-        final int idNegXNegZ = world.getBlockId(tilePos.west().north());
-        final int idPosXNegZ = world.getBlockId(tilePos.east().north());
-        final int idPosXPosZ = world.getBlockId(tilePos.east().south());
-        final int idNegXPosZ = world.getBlockId(tilePos.west().south());
+        TilePos queryPos = new TilePos();
+        final int idNegZ = world.getBlockId(tilePos.north(queryPos));
+        final int idPosZ = world.getBlockId(tilePos.south(queryPos));
+        final int idNegX = world.getBlockId(tilePos.west(queryPos));
+        final int idPosX = world.getBlockId(tilePos.east(queryPos));
+        final int idNegXNegZ = world.getBlockId(tilePos.west(queryPos).north(queryPos));
+        final int idPosXNegZ = world.getBlockId(tilePos.east(queryPos).north(queryPos));
+        final int idPosXPosZ = world.getBlockId(tilePos.east(queryPos).south(queryPos));
+        final int idNegXPosZ = world.getBlockId(tilePos.west(queryPos).south(queryPos));
         final boolean xNeighbor = idNegX == this.block.id() || idPosX == this.block.id();
         final boolean zNeighbor = idNegZ == this.block.id() || idPosZ == this.block.id();
         final boolean diagNeighbor = idNegXNegZ == this.block.id() || idPosXNegZ == this.block.id() || idPosXPosZ == this.block.id() || idNegXPosZ == this.block.id();
 
         final @NotNull TilePos localPos = new TilePos(tilePos);
-        for (localPos.x = tilePos.x - 1; localPos.x <= tilePos.x + 1; localPos.x++) {
-            for (localPos.z = tilePos.z - 1; localPos.z <= tilePos.z + 1; localPos.z++) {
-                final int id = world.getBlockId(tilePos.down());
+        for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
+            for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
+                final int id = world.getBlockId(tilePos.down(queryPos));
                 float growthRateMod = 0.0F;
                 if (id == Blocks.FARMLAND_DIRT.id()) {
                     growthRateMod = 1.0F;
-                    if (world.getBlockData(tilePos.down()) > 0) {
+                    if (world.getBlockData(tilePos.down(queryPos)) > 0) {
                         growthRateMod = 3F;
                     }
                 }
@@ -81,7 +83,7 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
             growthRate /= 2.0F;
         }
 
-        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down()));
+        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down(queryPos)));
         if (!isFertilized) {
             if (world.getSeasonManager().getCurrentSeason() != null) {
                 growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
@@ -93,12 +95,13 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     }
 
     @Override
-    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
-        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down()));
+    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
+        TilePos queryPos = new TilePos();
+        final boolean isFertilized = BlockLogicFarmland.isFertilized(world.getBlockData(tilePos.down(queryPos)));
         if (isFertilized && !world.isClientSide) {
             final boolean shouldDefertilize = world.rand.nextInt(3) == 2;
             if (shouldDefertilize) {
-                world.setBlockData(tilePos.down(), BlockLogicFarmland.setFertilized(world.getBlockData(tilePos.down()), false));
+                world.setBlockData(tilePos.down(queryPos), BlockLogicFarmland.setFertilized(world.getBlockData(tilePos.down(queryPos)), false));
             }
         }
     }
@@ -113,7 +116,7 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         if (world.getBlockData(tilePos) < MAX_GROWTH_STATE) {
             if (!world.isClientSide) {
                 world.setBlockDataNotify(tilePos, MAX_GROWTH_STATE);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java
index eccdd7670..d9d4c4e65 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCrystal.java
@@ -1,12 +1,11 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.block.material.Materials;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicCrystal extends BlockLogic {
     public BlockLogicCrystal(final @NotNull Block<?> block) {
-        super(block, Material.stone);
+        super(block, Materials.STONE);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index 662880ba0..0f35de874 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -4,6 +4,7 @@ import java.util.Objects;
 import java.util.Random;
 
 import net.minecraft.core.block.entity.TileEntityDispenser;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.*;
@@ -12,19 +13,19 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     public static final int MASK_POWERED = 0b0000_1000;
 
     public BlockLogicDispenser(final @NotNull Block<?> block) {
-        super(block, Material.stone);
+        super(block, Materials.STONE);
         block.withEntity(TileEntityDispenser::new);
     }
 
@@ -34,7 +35,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (world.isClientSide) {
             return true;
         } else {
@@ -44,7 +45,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
         }
     }
 
-    private void dispenseItem(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random random) {
+    private void dispenseItem(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random random) {
         final @NotNull Direction direction = BlockLogicVeryRotatable.metaToDirection(world.getBlockData(tilePos));
         final int xOffset = direction.getOffsetX();
         final int yOffset = direction.getOffsetY();
@@ -52,31 +53,31 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
 
         final @NotNull TileEntityDispenser tileEntity = (TileEntityDispenser) Objects.requireNonNull(world.getTileEntity(tilePos));
         final @Nullable ItemStack itemStack = tileEntity.getRandomStackFromInventory();
-        final @NotNull Vec3 pos = tilePos.into().add(xOffset * 0.6 + 0.5, yOffset * 0.6 + 0.5, zOffset * 0.6 + 0.5);
+        final @NotNull Vector3dc pos = new Vector3d(tilePos.x(), tilePos.y(), tilePos.z()).add(xOffset * 0.6 + 0.5, yOffset * 0.6 + 0.5, zOffset * 0.6 + 0.5);
         if (itemStack == null) {
             world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_EMPTY, 0);
         } else {
             if (itemStack.getItem() instanceof final @NotNull IDispensable dispensable) {
-                dispensable.onDispensed(itemStack, world, random, direction, pos.x, pos.y, pos.z);
+                dispensable.onDispensed(itemStack, world, random, direction, pos.x(), pos.y(), pos.z());
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id) {
                 final @NotNull ProjectileArrow arrow;
                 if (itemStack.itemID == Items.AMMO_ARROW.id) {
-                    arrow = new ProjectileArrow(world, pos.x, pos.y, pos.z, 0);
+                    arrow = new ProjectileArrow(world, pos.x(), pos.y(), pos.z(), 0);
                 } else {
-                    arrow = new ProjectileArrowGolden(world, pos.x, pos.y, pos.z);
+                    arrow = new ProjectileArrowGolden(world, pos.x(), pos.y(), pos.z());
                 }
                 arrow.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
                 arrow.setDoesArrowBelongToPlayer(true);
                 world.entityJoinedWorld(arrow);
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else if (itemStack.itemID == Items.AMMO_CHARGE_EXPLOSIVE.id) {
-                final @NotNull ProjectileCannonball projectileCannonball = new ProjectileCannonball(world, pos.x, pos.y, pos.z);
+                final @NotNull ProjectileCannonball projectileCannonball = new ProjectileCannonball(world, pos.x(), pos.y(), pos.z());
                 projectileCannonball.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
                 world.entityJoinedWorld(projectileCannonball);
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else {
-                final @NotNull EntityItem item = new EntityItem(world, pos.x, pos.y - 0.3D, pos.z, itemStack);
+                final @NotNull EntityItem item = new EntityItem(world, pos.x(), pos.y() - 0.3D, pos.z(), itemStack);
                 final double randOffset = random.nextDouble() * 0.1D + 0.2D;
                 item.xd = (double) xOffset * randOffset;
                 item.yd = (double) yOffset + 0.2D;
@@ -92,7 +93,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         final boolean hasNeighborSignal = world.hasNeighborSignal(tilePos);
         final int data = world.getBlockData(tilePos);
         if (hasNeighborSignal && (data & MASK_POWERED) == 0) {
@@ -104,7 +105,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.dispenseItem(world, tilePos, rand);
     }
 }
